package com.nisum.ecomcustomer.repository;

import com.nisum.ecomcustomer.model.Customer;
import org.springframework.data.mongodb.repository.MongoRepository;
import org.springframework.data.mongodb.repository.Query;

import java.util.List;
import java.util.Optional;

public interface CustomerRepository extends MongoRepository<Customer, Long> {

    Optional<Customer> findByEmailIgnoreCase(String email);

    @Query(value = "{'firstName': {$regex : ?0, $options: 'i'}}")
    List<Customer> findByFirstName(String fName);

    List<Customer> findByLastNameIgnoreCase(String lName);

    boolean existsByEmail(String email);

    boolean existsByEmailIn(List<String> emails);

}
