package com.nisum.ecomcustomer.controller;

import com.nisum.ecomcustomer.model.Customer;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestInstance;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.web.client.TestRestTemplate;
import org.springframework.boot.web.server.LocalServerPort;
import org.springframework.test.context.ActiveProfiles;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.TestInstance.Lifecycle;
import static org.springframework.boot.test.context.SpringBootTest.WebEnvironment;

@SpringBootTest(webEnvironment = WebEnvironment.DEFINED_PORT)
@TestInstance(Lifecycle.PER_CLASS)
@ActiveProfiles("test")
public class CustomerControllerIntegrationTest {

    @LocalServerPort
    private int port;

    private String url;

    @Autowired
    TestRestTemplate testRestTemplate;

    @BeforeAll
    public void setUp() {
        url = "http://localhost:" + port + "/customer";
    }

    @Test
    public void testGetById() {
        Customer responseObject = testRestTemplate.getForObject(url + "/id/2", Customer.class);
        assertEquals("Ashokk", responseObject.getFirstName());
    }

}
